#NoTrayIcon
#Region ;**** Directives created by AutoIt3Wrapper_GUI ****
#AutoIt3Wrapper_Icon=..\res\client.ico
#AutoIt3Wrapper_Outfile=..\Client.exe
#AutoIt3Wrapper_Compression=4
#AutoIt3Wrapper_Res_Fileversion=1.0.0.0
#AutoIt3Wrapper_Res_LegalCopyright=Matwachich - 2011
#EndRegion ;**** Directives created by AutoIt3Wrapper_GUI ****
#cs ----------------------------------------------------------------------------

 AutoIt Version: 3.3.6.1
 Author:         Matwachich

 Script Function:
	Assistance  distance - Client (Personne ayant besoin d'aide)

#ce ----------------------------------------------------------------------------

Global Const $__ProgName = "Remote Assist - Client"
Global $oClient

#include <..\lib\TCPClass\Client.au3>

#include "Graphics.au3"
#include "GUI.au3"

Global $__Scr_Auto = 0, $__Scr_Delay = 5000, $__Scr_Timer
Global $__FileBuffer = 0, $__FileName = ""
Global $__Connected = 0

Global $__AnimArray[4] = ["--", "\", "|", "/"]
Global $__AnimPos = 0, $__AnimTimer = TimerInit()

_AutoItObject_Startup()
TCPStartup()
OnAutoItExitRegister("__OnExit")
Func __OnExit()
	_AutoItObject_Shutdown()
	TCPShutdown()
EndFunc

Global $oClient = _Class_TCPClient()

_GUI_Connect()
_GUI_Main()

; ##############################################################
; Main Program

While 1
	Do
	Until _Connect()
	; ---
	_Main()
WEnd

; ##############################################################
; Connection

Func _Connect()
	_GUI_Connect($__GUI_SHOW)
	; ---
	While 1
		Switch GuiGetMsg()
			Case $GUI_EVENT_CLOSE
				Exit
			Case $B_GO
				ExitLoop
		EndSwitch
	WEnd
	_GUI_Connect($__GUI_HIDE)
	$oClient.server_ip = GuiCtrlRead($I_IP)
	$oClient.server_port = GuiCtrlRead($I_Port)
	; ---
	If $oClient.Connect("_TCP_Recv", "_TCP_Receiving", "_TCP_LostConnection") > 0 And Not @error Then
		$__Connected = 1
		Return 1
	Else
		Return 0
	EndIf
EndFunc

; ##############################################################
; Main Loop

Func _Main()
	Opt("GuiOnEventMode", 1)
	_GUI_Main($__GUI_SHOW)
	; ---
	GuiCtrlSetData($I_ScrW, 800)
	GuiCtrlSetData($I_ScrH, 600)
	; ---
	Local $recv
	While $__Connected
		$oClient.Process()
		_Process()
	WEnd
	; ---
	MsgBox(48, $__ProgName, "La connexion avec le serveur a t perdue!")
	_GUI_Main($__GUI_HIDE)
	Opt("GuiOnEventMode", 0)
EndFunc

Func _Process()
	If $__FileBuffer And $__FileName Then
		Local $hF = FileOpen(@ScriptDir & "\" & $__FileName, 18)
		FileWrite($hF, $__FileBuffer)
		FileClose($hF)
		; ---
		$__FileBuffer = 0
		$__FileName = ""
	EndIf
	; ---
	If $__Scr_Auto Then
		If TimerDiff($__Scr_Timer) >= $__Scr_Delay Then
			_Event_Scr()
			$__Scr_Timer = TimerInit()
		EndIf
	EndIf
EndFunc

Func _TCP_Recv($data)
	ConsoleWrite("Received: " & VarGetType($data) & " (" & BinaryLen($data) & ")" & @CRLF)
	If StringLeft($data, 1) = "." Then
		Switch StringLeft($data, 5)
			Case ".msg:"
				GuiCtrlSetData($E_Chat, "[Assistant] " & StringTrimLeft($data, 5) & @CRLF, 1)
			Case ".clk:"
				Local $text = StringTrimLeft($data, 5)
				$text = StringSplit($text, "|")
				If IsArray($text) And $text[0] = 3 Then _
					_Gfx_Circle($text[1] * @DesktopWidth, $text[2] * @DesktopHeight, $text[3])
			Case ".fil:"
				$__FileName = StringTrimLeft($data, 5)
		EndSwitch
	Else
		$__FileBuffer = 0
		$__FileBuffer = $data
	EndIf
EndFunc

Func _TCP_LostConnection()
	$__Connected = 0
EndFunc

Func _TCP_Receiving($len)
	_AnimTitle($len)
EndFunc

; ##############################################################
; Events

Func _Event_Scr()
	$oClient.Send(".dbg:Envoi capture ...")
	$oClient.Send(_Gfx_ScreenCapture(GuiCtrlRead($I_ScrW), GuiCtrlRead($I_ScrH)))
EndFunc

Func _Event_Chat()
	Local $read = GuiCtrlRead($I_Chat)
	If Not $read Or Not ControlFocus($GUI_Main, "", $I_Chat) Or $oClient.socket = -1 Then Return
	; ---
	$oClient.Send(".msg:" & $read)
	GuiCtrlSetData($E_Chat, "[Vous] " & $read & @CRLF, 1)
	GuiCtrlSetData($I_Chat, "")
EndFunc

Func _Event_AutoScr()
	If GuiCtrlRead($C_AutoScr) = $GUI_CHECKED Then
		If GuiCtrlRead($I_Delay) = "" Then GuiCtrlSetData($I_Delay, 5)
		$__Scr_Delay = GuiCtrlRead($I_Delay) * 1000
		$__Scr_Timer = TimerInit()
		$__Scr_Auto = 1
	Else
		$__Scr_Auto = 0
	EndIf	
EndFunc

Func _Event_Close()
	If MsgBox(36, $__ProgName, "Voulez-vous vraiment quitter?") = 6 Then
		$__Connected = 0
		Exit
	EndIf
EndFunc

; ##############################################################
; Title Animation

Func _AnimTitle($len)
	If TimerDiff($__AnimTimer) >= 100 Then
		Local $title = "Rception... (" & $len & ")"
		WinSetTitle($GUI_Main, "", $title)
		$__AnimPos += 1
		If $__AnimPos > 3 Then $__AnimPos = 0
		$__AnimTimer = TimerInit()
	EndIf
	; ---
	AdlibRegister("_AnimTitleReset", 1000)
EndFunc

Func _AnimTitleReset()
	WinSetTitle($GUI_Main, "", $__ProgName)
	AdlibUnregister("_AnimTitleReset")
EndFunc