#cs ----------------------------------------------------------------------------

 AutoIt Version: 3.3.6.1
 Author:         Matwachich

 Script Function:
	Dessin direct sur l'cran

#ce ----------------------------------------------------------------------------
#Region ### Functions ###
#cs
- Main Functions
	_DesktopDraw_Start($penStyle = $PS_SOLID, $penWidth = 2, $penColor = 0xFFFFFF)
	_DesktopDraw_PenChange($penStyle, $penWidth, $penColor)
	_DesktopDraw_End()
	; ---
	_DesktopDraw_Line($x1, $y1, $x2, $y2)
	_DesktopDraw_Pixel($x, $y)
	_DesktopDraw_Cross($x, $y, $length = 40, $centerLigneDistance = 10)
	_DesktopDraw_Cercle($x, $y, $diametre = 40)
	_DesktopDraw_CerclePlein($x, $y, $diametre = 40)
	_DesktopDraw_Rectangle($x, $y, $width, $height)
	_DesktopDraw_RectanglePlein($x, $y, $width, $height)
	_DesktopDraw_Losange($x, $y, $width, $height)
	_DesktopDraw_LosangePlein($x, $y, $width, $height)
	_DesktopDraw_MoveTo($x, $y)
	_DesktopDraw_LineTo($x, $y)
	; ---
	__DesktopDraw_IsInit()
	__DesktopDraw_pixelsDist($x1, $y1, $x2, $y2)
	__DesktopDraw_RGB_to_BGR($rgb)
#ce
#EndRegion ###

#include <WindowsConstants.au3>
#include <WinAPI.au3>
#include <Math.au3>
#include <Misc.au3>

Global $__DesktopDraw_DrawHandle[3] = [0, 0, 0]

#cs
HotKeySet("{esc}", "_exit")

_DesktopDraw_Start($PS_SOLID, 1, 0xFFFFFF)
$_user32_dll = DllOpen("user32.dll")

;~ _DesktopDraw_CerclePlein(@DesktopWidth/2, @DesktopHeight/2, 150)
;~ _DesktopDraw_Cercle(@DesktopWidth/2, @DesktopHeight/2, 200)
;~ _DesktopDraw_RectanglePlein(@DesktopWidth/2, @DesktopHeight/2, 100, 100)
;~ _DesktopDraw_Rectangle(@DesktopWidth/2, @DesktopHeight/2, 200, 200)
;~ _DesktopDraw_Pixel(@DesktopWidth/2, @DesktopHeight/2)
;~ _DesktopDraw_Losange(@DesktopWidth/2, @DesktopHeight/2, 300, 800)

Global $old_mouse_pos[2] = [0, 0]
$mouse_pos = MouseGetPos()
_DesktopDraw_MoveTo($mouse_pos[0], $mouse_pos[1])

While 1
	$mouse_pos = MouseGetPos()
;~ 	If $mouse_pos[0] <> $old_mouse_pos[0] Or $mouse_pos[1] <> $old_mouse_pos[1] Then
;~ 		_DesktopDraw_LineTo($mouse_pos[0], $mouse_pos[1])
;~ 		_DesktopDraw_Cross($mouse_pos[0], $mouse_pos[1])
;~ 		$old_mouse_pos[0] = $mouse_pos[0]
;~ 		$old_mouse_pos[1] = $mouse_pos[1]
;~ 	EndIf
	If _IsPressed('01', $_user32_dll) Then
		_DesktopDraw_PenChange($PS_SOLID, 3, 0xFF0000)
		_DesktopDraw_Cercle($mouse_pos[0], $mouse_pos[1])
		_DesktopDraw_PenChange($PS_SOLID, 1, 0xFFFFFF)
		_DesktopDraw_MoveTo($mouse_pos[0], $mouse_pos[1])
	EndIf
	Sleep(1)
WEnd

Func _exit()
	_DesktopDraw_End()
	DllClose($_user32_dll)
	Exit
EndFunc
#ce

Func _DesktopDraw_Start($penStyle = $PS_SOLID, $penWidth = 2, $penColor = 0xFFFFFF)
	If __DesktopDraw_IsInit() Then Return 0
	Local $hDC, $hPen, $obj_orig
	$hDC = _WinAPI_GetWindowDC(0) ; DC of entire screen (desktop)
    $hPen = _WinAPI_CreatePen($penStyle, $penWidth, __DesktopDraw_RGB_to_BGR($penColor))
    $obj_orig = _WinAPI_SelectObject($hDC, $hPen)
	$__DesktopDraw_DrawHandle[0] = $hDC
	$__DesktopDraw_DrawHandle[1] = $hPen
	$__DesktopDraw_DrawHandle[2] = $obj_orig
	Return 1
EndFunc

Func _DesktopDraw_PenChange($penStyle, $penWidth, $penColor)
	If Not __DesktopDraw_IsInit() Then Return 0
;~ 	_DesktopDraw_End()
;~ 	_DesktopDraw_Start($penStyle, $penWidth, $penColor)
	$__DesktopDraw_DrawHandle[1] = _WinAPI_CreatePen($penStyle, $penWidth, __DesktopDraw_RGB_to_BGR($penColor))
	$__DesktopDraw_DrawHandle[2] = _WinAPI_SelectObject($__DesktopDraw_DrawHandle[0], $__DesktopDraw_DrawHandle[1])
	Return 1
EndFunc

Func _DesktopDraw_End()
	If Not __DesktopDraw_IsInit() Then Return 0
	_WinAPI_SelectObject($__DesktopDraw_DrawHandle[0], $__DesktopDraw_DrawHandle[2])
    _WinAPI_DeleteObject($__DesktopDraw_DrawHandle[1])
    _WinAPI_ReleaseDC(0, $__DesktopDraw_DrawHandle[0])
	For $i = 0 To 2
		$__DesktopDraw_DrawHandle[$i] = 0
	Next
	Return 1
EndFunc

Func _DesktopDraw_Line($x1, $y1, $x2, $y2)
	If Not __DesktopDraw_IsInit() Then Return 0
;~ 	_WinAPI_DrawLine($__DesktopDraw_DrawHandle[0], $x1, $y1, $x2, $y1)
;~ 	_WinAPI_RedrawWindow(_WinAPI_GetDesktopWindow(), 0, 0, $RDW_INVALIDATE + $RDW_ALLCHILDREN)
	_DesktopDraw_MoveTo($x1, $y1)
	_DesktopDraw_LineTo($x2, $y2)
	Return 1
EndFunc

Func _DesktopDraw_Pixel($x, $y)
	If Not __DesktopDraw_IsInit() Then Return 0
	_DesktopDraw_Line($x, $y, $x, $y)
EndFunc

Func _DesktopDraw_Cross($x, $y, $length = 40, $centerLigneDistance = 10)
	If Not __DesktopDraw_IsInit() Then Return 0
	_DesktopDraw_Line($x - $length, $y, $x - $centerLigneDistance, $y)
	_DesktopDraw_Line($x + $length, $y, $x + $centerLigneDistance, $y)
	_DesktopDraw_Line($x, $y - $length, $x, $y - $centerLigneDistance)
	_DesktopDraw_Line($x, $y + $length, $x, $y + $centerLigneDistance)
	Return 1
EndFunc

Func _DesktopDraw_Cercle($x, $y, $diametre = 40)
	If Not __DesktopDraw_IsInit() Then Return 0
	_DesktopDraw_MoveTo($x + $diametre/2, $y)
	For $i = 0 To 360 Step 30
		_DesktopDraw_LineTo($x + (Cos(_Radian($i)) * ($diametre/2)), $y + (Sin(_Radian($i)) * ($diametre/2)))
	Next
;~ 	_DesktopDraw_MoveTo($x + $diametre, $y)
EndFunc

Func _DesktopDraw_CerclePlein($x, $y, $diametre = 40)
	If Not __DesktopDraw_IsInit() Then Return 0
	For $i = 0 To 360 Step 5
		_DesktopDraw_Line($x, $y, $x + (Cos(_Radian($i)) * ($diametre/2)), $y + (Sin(_Radian($i)) * ($diametre/2)))
	Next
	Return 1
EndFunc

Func _DesktopDraw_Rectangle($x, $y, $width, $height)
	If Not __DesktopDraw_IsInit() Then Return 0
	_DesktopDraw_MoveTo($x, $y)
	_DesktopDraw_LineTo($x + $width, $y)
	_DesktopDraw_LineTo($x + $width, $y + $height)
	_DesktopDraw_LineTo($x, $y + $height)
	_DesktopDraw_LineTo($x, $y)
	Return 1
EndFunc

Func _DesktopDraw_RectanglePlein($x, $y, $width, $height)
	If Not __DesktopDraw_IsInit() Then Return 0
	For $i = 0 To $height
		_DesktopDraw_Line($x, $y + $i, $x + $width, $y + $i)
	Next
	Return 1
EndFunc

Func _DesktopDraw_Losange($x, $y, $width, $height)
	If Not __DesktopDraw_IsInit() Then Return 0
	_DesktopDraw_MoveTo($x + ($width/2), $y)
	_DesktopDraw_LineTo($x, $y + ($height/2))
	_DesktopDraw_LineTo($x - ($width/2), $y)
	_DesktopDraw_LineTo($x, $y - ($height/2))
	_DesktopDraw_LineTo($x + ($width/2), $y)
	Return 1
EndFunc

Func _DesktopDraw_LosangePlein($x, $y, $width, $height)
EndFunc

Func _DesktopDraw_MoveTo($x, $y)
	If Not __DesktopDraw_IsInit() Then Return 0
	Return _WinAPI_MoveTo($__DesktopDraw_DrawHandle[0], $x, $y)
EndFunc

Func _DesktopDraw_LineTo($x, $y)
	If Not __DesktopDraw_IsInit() Then Return 0
	Return _WinAPI_LineTo($__DesktopDraw_DrawHandle[0], $x, $y)
EndFunc

Func __DesktopDraw_IsInit()
	If $__DesktopDraw_DrawHandle[0] = 0 Then
		Return 0
	Else
		Return 1
	EndIf
EndFunc

Func __DesktopDraw_pixelsDist($x1, $y1, $x2, $y2)
	Local $distX = $x2 - $x1, $distY = $y2 - $y1
	Return sqrt(($distX * $distX) + ($distY * $distY))
EndFunc

Func __DesktopDraw_RGB_to_BGR($rgb)
	$rgb = StringTrimRight(Binary($rgb), 2)
	If Not StringInStr($rgb, "0x") Or StringLen($rgb) <> 8 Then Return 0
	$rgb = StringRight($rgb, 6)
	$b = StringRight($rgb, 2)
	$r = StringLeft($rgb, 2)
	$g = StringMid($rgb, 3, 2)
	Local $bgr = Binary("0x" & $b & $g & $r)
	Return $bgr
EndFunc
