
#include <WinAPI.au3>
#include <..\lib\Bitmap_String.au3>

Func _DisplayScr($binStr)
	Local $Bitmap = _BinaryString2Bitmap($binStr)
	;Local $hBitmap = _GDIPlus_BitmapCreateHBitmapFromBitmap($Bitmap)
	;_SetHImage($Pic_Scr, $hBitmap)
	;_WinApi_DeleteObject($hBitmap)
	; ---
	Local $graphic = _GDIPlus_GraphicsCreateFromHWND(GuiCtrlGetHandle($Pic_Scr))
	_GDIPlus_GraphicsDrawImageRectRect($graphic, $Bitmap, 0, 0, _GDIPlus_ImageGetWidth($Bitmap), _GDIPlus_ImageGetHeight($Bitmap), _
														0, 0, 800, 600)
	; ---
	_GDIPlus_GraphicsDispose($graphic)
	_GDIPlus_BitmapDispose($Bitmap)
EndFunc

Func _Dbg($text)
	GuiCtrlSetData($E_Console, "[" & @HOUR & ":" & @MIN & ":" & @SEC & "] " & $text & @CRLF, 1)
EndFunc

; ##############################################################
; TCP Events

Func _TCP_New($socket, $ip)
	_Dbg("Client " & $ip & " connect")
	$hClientSocket = $socket
EndFunc

Func _TCP_Lost($socket, $ip)
	_Dbg("Client " & $ip & " dconnect")
	$hClientSocket = -1
EndFunc

Func _TCP_Receiving($socket, $ip, $len)
	_AnimTitle($len)
EndFunc

Func _TCP_Recv($socket, $ip, $data)
	ConsoleWrite("Received: " & VarGetType($data) & " (" & BinaryLen($data) & ")" & @CRLF)
	; ---
	If StringLeft($data, 1) = "." Then
		Switch StringLeft($data, 5)
			Case ".msg:"
				GuiCtrlSetData($E_Chat, "[Client] " & StringTrimLeft($data, 5) & @CRLF, 1)
			Case ".dbg:"
				_Dbg("Client: " & StringTrimLeft($data, 5))
		EndSwitch
	Else
		_DisplayScr($data)
	EndIf
EndFunc

Func _TCP_Timedout($socket, $ip, $len)
	_Dbg("Timed Out - Lost: " & $len)
EndFunc

; ##############################################################
; Title Animation

Global $__AnimArray[4] = ["--", "\", "|", "/"]
Global $__AnimPos = 0, $__AnimTimer = TimerInit()

Func _AnimTitle($len)
	If TimerDiff($__AnimTimer) >= 100 Then
		Local $title =  "Rception ... (" & $len & ")"
		WinSetTitle($GUI_Main, "", $__ProgName & " - " & $title)
		$__AnimPos += 1
		If $__AnimPos > 3 Then $__AnimPos = 0
		$__AnimTimer = TimerInit()
	EndIf
	; ---
	AdlibRegister("_AnimTitleReset", 1000)
EndFunc

Func _AnimTitleReset()
	WinSetTitle($GUI_Main, "", $__ProgName)
	AdlibUnregister("_AnimTitleReset")
EndFunc

; ##############################################################
; Misc

Func __Check_IP($ip)
	$ip = StringSplit($ip, ".")
	If $ip[0] <> 4 Then
		__GuiInit_CtrlRed($C_IP)
		Return 0
	EndIf
	; ---
	For $i = 1 To 4
		If Int($ip[$i]) <> $ip[$i] Or $ip[$i] < 0 Or $ip[$i] > 255 Then
			__GuiInit_CtrlRed($C_IP)
			Return 0
		EndIf
	Next
	; ---
	Return 1
EndFunc

Func __Check_Port($port)
	If Not $port Or Int($port) <> $port Or $port < 1 Or $port > 65535 Then
		__GuiInit_CtrlRed($I_Port)
		Return 0
	Else
		Return 1
	EndIf
EndFunc

Func __GuiInit_ResetBkColor()
	GuiCtrlSetBkColor($C_IP, 0xFFFFFF)
	GuiCtrlSetBkColor($I_Port, 0xFFFFFF)
	GuiCtrlSetColor($C_IP, 0x000000)
	GuiCtrlSetColor($I_Port, 0x000000)
	; ---
	AdLibUnregister("__GuiInit_ResetBkColor")
EndFunc

Func __GuiInit_CtrlRed($ctrl)
	GuiCtrlSetBkColor($ctrl, 0xFF7514)
	GuiCtrlSetColor($ctrl, 0xFFFFFF)
	AdLibRegister("__GuiInit_ResetBkColor", 2000)
EndFunc

Func _File_GetName($path)
	Return StringTrimLeft($path, StringInStr($path, "\", 1, -1))
EndFunc