#NoTrayIcon
#Region ;**** Directives created by AutoIt3Wrapper_GUI ****
#AutoIt3Wrapper_Icon=..\res\server.ico
#AutoIt3Wrapper_Outfile=..\Serveur.exe
#AutoIt3Wrapper_Compression=4
#AutoIt3Wrapper_Res_Fileversion=1.0.0.0
#AutoIt3Wrapper_Res_LegalCopyright=Matwachich - 2011
#EndRegion ;**** Directives created by AutoIt3Wrapper_GUI ****
#cs ----------------------------------------------------------------------------

 AutoIt Version: 3.3.6.1
 Author:         Matwachich

 Script Function:
	Assistance  distance - Serveur (Personne offrant sont aide au client)

#ce ----------------------------------------------------------------------------

Global Const $__ProgName = "Remote Assist - Serveur"
Global $__IP, $__Port
Global $hClientSocket = -1
Global $runing = 1

#include <..\lib\TCPClass\Server.au3>
#include <GDIPlus.au3>

#include "GUI.au3"
#include "Funcs.au3"

; ---
_GUI_Init()
_GUI_Init($__GUI_SHOW)

While 1
	Switch GuiGetMsg()
		Case $GUI_EVENT_CLOSE
			Exit
		Case $B_Init_Quit
			Exit
		Case $B_Init_Go
			If __Check_IP(GuiCtrlRead($C_IP)) And __Check_Port(GuiCtrlRead($I_Port)) Then ExitLoop
	EndSwitch
Wend

$__IP = GuiCtrlRead($C_IP)
$__Port = GuiCtrlRead($I_Port)

_GUI_Init($__GUI_DELETE)
; ##############################################################

Opt("GuiOnEventMode", 1)
Opt("MouseCoordMode", 2)

_AutoItObject_Startup()
TCPStartup()
_GDIPlus_Startup()
OnAutoItExitRegister("__OnExit")
Func __OnExit()
	_GDIPlus_Shutdown()
	TCPShutdown()
	_AutoItObject_Shutdown()
EndFunc

; ##############################################################
; Startup

$oServer = _Class_TCPServer($__IP, $__Port, 1)
_GUI_Main()

If $oServer.Startup("_TCP_New", "_TCP_Lost", "_TCP_Recv", "_TCP_Receiving", "_TCP_Timedout") > 0 Then
	_Dbg("Serveur en ligne sur " & @IPAddress1 & ":" & $__Port)
Else
	Exit MsgBox(16, $__ProgName, "Le serveur n'a pas pu tre dmarer." & @CRLF & "Erreur: " & @error)
EndIf

_GUI_Main($__GUI_SHOW)

; ##############################################################
; Program loop

While $runing
	$oServer.Process()
	; ---
	;Sleep(10)
WEnd

; ##############################################################
; Events

Func _Event_ScrClick()
	Local $mos = MouseGetPos()
	$mos[0] = $mos[0] / 800
	$mos[1] = $mos[1] / 600
	; ---
	$oServer.Send($hClientSocket, ".clk:" & $mos[0] & "|" & $mos[1] & "|40")
EndFunc

Func _Event_SendFile()
	Local $path = FileOpenDialog("Envoi de fichier", @DesktopDir, "All (*.*)", 1+2)
	If Not $path Or @error Then Return
	; ---
	Local $hF = FileOpen($path, 16)
	$oServer.Send($hClientSocket, ".fil:" & _File_GetName($path))
	$oServer.Send($hClientSocket, FileRead($hF))
	FileClose($hF)
EndFunc

Func _Event_Chat()
	Local $read = GuiCtrlRead($I_Chat)
	If Not $read Or Not ControlFocus($GUI_Main, "", $I_Chat) Or $hClientSocket = -1 Then Return
	; ---
	$oServer.Send($hClientSocket, ".msg:" & $read)
	GuiCtrlSetData($E_Chat, "[Vous] " & $read & @CRLF, 1)
	GuiCtrlSetData($I_Chat, "")
EndFunc

Func _Event_Close()
	$runing = 0
EndFunc
